#Challenge 3 Program to play simon says game using integers, adding features of reporting sequence length
# play again, checking for errors in user input and reporting maximum score to date

import random, time
play_again = True
high_score = 0
length = 0
while play_again == True:
    high_score = length
    print('Your highest score in all games sofar is ',high_score)
    print()
    int_range = int(input('What is the highest random integer you would like to be used in the new sequence? '))

#Here is a technique for making sure the delay entered is a number. It uses 'exception handling'.
#The code that can cause exception is placed inside a try block.
#If no exception occurs, the while loop is escaped because of the break instruction as the except block is skipped.
#Normal flow continues. If a ValueError exception occurs, it is caught by the except block and the while loop is repeated.
    while True:
        delay = input('How many seconds would you like to view each sequence? ')
        try:
            delay = float(delay)
            break
        except ValueError:
            print('Please enter in a number.\n')
            continue
    print()
    sequence = []
    flag=True
    while flag==True:
        newint=random.randint(1,int_range)
        sequence.append(newint)
        length = len(sequence)
        print('Your new sequence is',sequence)
        print('Wait! Answer after scrolling ends')
        time.sleep(delay)
        for lines in range(1,40):
            print()
        print('type the sequence with spaces between each number ')
        playersequence=[int(x) for x in input().split()]
        if playersequence==sequence:
            flag=True       
            print ('success!')
            print('You have now successfully remembered a sequence of',length,'numbers')
            print('Your highest score in all games sofar is ',high_score)
            print()
        else:
            flag=False
            print('Fail!')
    play = input('Would you like to play again? ')
    if play in ['Y','y', 'yes', 'Yes', 'T', 'True']:  # lots of the ways to say yes!
        play_again = True
    else:
        print('Farewell!')
        play_again  = False

#Additional challenge! If a user enters a sequence which includes, say a letter of the alphabet,
#then the program crashes rather than asking for the entry to be retyped.
#This can be achieved using the method of exception handling illustrated above.  can you do it?
    
