/*
 * Dice_Roll_Function
 * A sketch to roll through a series of dice numbers
 * and then settle on a random number from 1 to 6 in a dice pattern on 7 LEDs
 * This sketch uses the random() and randomSeed() functions
 * using code from https://www.arduino.cc/en/Tutorial/Arrays
 * https://www.arduino.cc/en/Reference/RandomSeed
 * Modified by Seven Vinton for Cengage Learning February 2017
 * This sketch is in the public domain
 */

int led_pins[] = {3,4,5,6,7,8,9};
int button1 = 2;
int buttonState;
int ran;
int pause = 100;

void setup() {
for (int thisPin = 0; thisPin < 7; thisPin++) {
    pinMode(led_pins[thisPin], OUTPUT);
}
  pinMode(button1, INPUT_PULLUP);
  randomSeed(analogRead(A0));
}
void loop() {
  buttonState = digitalRead(button1);
  if (buttonState == LOW){
  pause = 500;
  for(int roll = 1; roll <7; roll++){
  diceRoll();
  pause+=100;
  }
  }
  }

void diceRoll(){
    
    for (int thisPin = 0; thisPin < 7; thisPin++) {
    digitalWrite(led_pins[thisPin], LOW);
    }
    delay(pause);
    ran = random(1, 7);
    if (ran == 1){
      digitalWrite (led_pins[3], HIGH);
      delay (pause);
    }
    if (ran == 2){
      digitalWrite (led_pins[2], HIGH);
      digitalWrite (led_pins[4], HIGH);
      delay (pause);
    }
    if (ran == 3){
      digitalWrite (led_pins[2], HIGH);
      digitalWrite (led_pins[3], HIGH);
      digitalWrite (led_pins[4], HIGH);
      delay (pause);
    }
    if (ran == 4){
      digitalWrite (led_pins[0], HIGH);
      digitalWrite (led_pins[1], HIGH);
      digitalWrite (led_pins[5], HIGH);
      digitalWrite (led_pins[6], HIGH);
      delay (pause);
    }
    if (ran == 5){
      digitalWrite (led_pins[0], HIGH);
      digitalWrite (led_pins[1], HIGH);
      digitalWrite (led_pins[3], HIGH);
      digitalWrite (led_pins[5], HIGH);
      digitalWrite (led_pins[6], HIGH);
      delay (pause);
   }
   if (ran == 6){
     digitalWrite (led_pins[0], HIGH);
     digitalWrite (led_pins[1], HIGH);
     digitalWrite (led_pins[2], HIGH);
     digitalWrite (led_pins[4], HIGH);
     digitalWrite (led_pins[5], HIGH);
     digitalWrite (led_pins[6], HIGH);
     delay (pause);
   }
}

