##Challenge 6
##Program to generate random multiplication, addition, subtraction and division questions and give result as percentage
##User is asked for number of questions and if wishes to play again
##Repeats question until correct answer given.
##This version removes the possibility of negative answers for subtraction
##and makes sure that division results in integers only (no remainders)


import random
flag = True
while flag == True:
    score = 0
    questions=int(input('How many questions would you like? '))
    print('You have asked for',questions,'questions')
    print()
    counter = 1    
    while counter<=questions:
        check = False
        first_num=random.randint(1,12)
        second_num=random.randint(1,12)
        operation = ['X', '+', '-','/']
        op_selected = random.choice(operation)
        if op_selected == 'X':
            correct = first_num * second_num
        if op_selected == '+':
            correct = first_num + second_num
        if op_selected == '-':
            #Making sure the second number is less than or equal to the first number when subtracting (to avoid negative answers)
            while first_num < second_num:
                first_num=random.randint(1,12)
                second_num=random.randint(1,12)
            correct = first_num - second_num
        if op_selected == '/':
            #Making sure division has no remainder (to avoid fractional answers). The '%' symbol in Python divides
            #left hand operand by right hand operand and returns the remainder. So here we keep randomly generating
            #our two operands until we have a remainder which is zero
            while first_num % second_num != 0:
                first_num=random.randint(1,12)
                second_num=random.randint(1,12)
            correct = first_num/second_num
            #We could use the '/' symbol for division as computers do but here we have replaced this with the UniCode symbol for division.
            op_selected = u'\u00F7'   
        while check == False:
            print ('Question',counter,': ',first_num,op_selected,second_num,'=',)
            answer=int(input('Answer? '))
            if answer == correct:
                print('Correct!')
                score+=1
                check = True
            else:
                print ('Incorrect')
                print('Try again! You will not lose marks if you can get it correct')
        counter+=1
    print()
    print('Score is',score, 'out of', questions)
    print ('You had',str(score/questions*100)+"%","correct")
    print()
    flag = False
    play = input('Would you like to play again? ')
    print()
    if play in ['Y','y', 'yes', 'Yes', 'T', 'True']:  # lots of the ways to say yes!
        flag = True
    else:
        print('Farewell! Practice makes perfect!')
        flag = False
    
